#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,abm")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define x first
#define y second
#define pb push_back
#define all(x) x.begin(),x.end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<pii> vpii;
typedef vector<pll> vpll;

const int N = 1e6 + 5;
const int infe9 = 1e9 + 5;
const int infe18 = (ll)1e18 + 5;

struct DSU {
    vi pr, sz;
    DSU(int n) {
        pr.resize(n + 5);
        sz.resize(n + 5, 1);
        iota(all(pr), 0);
    }
    int get(int x) {
        return (x == pr[x] ? x : pr[x] = get(pr[x]));
    }
    bool unite(int x, int y) {
        if (x == y) return 1;
        x = get(x);
        y = get(y);
        if (x == y) return 0;
        if (sz[x] < sz[y]) swap(x, y);
        pr[y] = x;
        sz[x] += sz[y];
        return 1;
    }
};

vi g[N];
pii edge[N];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int x, y;
        cin >> x >> y;
        edge[i] = {x, y};
    }
    DSU dsu(n);
    vi ch_dsu, ch_g;
    int ans = 0;
    for (int i = 1; i <= m; ++i) {
        ++ans;
        for (int j : ch_dsu) dsu.pr[j] = j, dsu.sz[j] = 1;
        for (int j : ch_g) g[j].clear();
        ch_dsu.clear();
        ch_g.clear();
//        for (int j = 1; j <= n; ++j) dsu.pr[j] = j, dsu.sz[j] = 1;
//        for (int j = 1; j <= n; ++j) g[j].clear();
        g[edge[i].x].pb(edge[i].y); ch_g.pb(edge[i].x);
        g[edge[i].y].pb(edge[i].x); ch_g.pb(edge[i].y);
        for (; i + 1 <= m; ++i) {
            auto [x, y] = edge[i + 1];
            g[x].pb(y); ch_g.pb(x);
            g[y].pb(x); ch_g.pb(y);
            bool stop = 0;
            for (int z : g[x]) {
                if (z == y || z == x) continue;
                ch_dsu.pb(y); ch_dsu.pb(z);
                if (!dsu.unite(z, y)) {
                    stop = 1;
                    break;
                }
            }
            if (stop) break;
            for (int z : g[y]) {
                if (z == x || z == y) continue;
                ch_dsu.pb(x); ch_dsu.pb(z);
                if (!dsu.unite(z, x)) {
                    stop = 1;
                    break;
                }
            }
            if (stop) break;
        }
    }
    cout << ans;
}

int32_t main() {
    cin.tie(NULL)->ios_base::sync_with_stdio(false);
    solve();
}
