#include <bits/stdc++.h>
using namespace std;
using pii = pair<int, int>;
const int msz = 1e6 + 5;

struct ST{
    vector<int> t, p;
    int n;
    ST(int ns){
        n = ns;
        t.resize(4 * n);
        p.resize(4 * n);
    }
    void push(int& v, int& vv){
        if (!p[v]) return;
        t[vv] = p[v]; t[vv + 1] = p[v];
        p[vv] = p[v]; p[vv + 1] = p[v];
    }
    void upd(int v, int tl, int tr, int& l, int& r, int& val){
        if (l > tr || r < tl) return;
        if (l <= tl && tr <= r){
            t[v] = val;
            p[v] = val;
            return;
        }
        int tm = (tl + tr) / 2, vv = 2 * v;
        push(v, vv);
        upd(vv, tl, tm, l, r, val);
        upd(vv + 1, tm + 1, tr, l, r, val);
        t[v] = max(t[vv], t[vv + 1]);
    }
    void upd(int l, int r, int v){
        upd(1, 1, n, l, r, v);
    }
    int get(int v, int tl, int tr, int& l, int& r){
        if (l > tr || r < tl) return 0;
        if (l <= tl && tr <= r) return t[v];
        int tm = (tl + tr) / 2, vv = 2 * v;
        push(v, vv);
        return max(get(vv, tl, tm, l, r), get(vv + 1, tm + 1, tr, l, r));
    }
    int get(int l, int r){
        return get(1, 1, n, l, r);
    }
};

int n, m;
vector<pii> edges;
vector<int> g[msz], gr(msz);
vector<bool> used(msz);

void fill(int v){
    used[v] = true;
    for (int i: g[v]){
        if (used[i]) continue;
        gr[i] = 3 - gr[v];
        fill(i);
    }
}

bool check(int x, int y){
    for (int i = 1; i <= n; i++){
        g[i].clear();
        used[i] = false;
    }
    for (int i = x; i <= y; i++){
        auto [u, v] = edges[i];
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 1; i <= n; i++){
        if (used[i]) continue;
        gr[i] = 1;
        fill(i);
    }
    for (int i = x; i <= y; i++){
        auto [u, v] = edges[i];
        if (gr[u] + gr[v] != 3){
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    edges.resize(m + 1);
    for (int i = 1; i <= m; i++){
        cin>>edges[i].first>>edges[i].second;
    }
    int i = 1, out = 0;
    while (i <= m){
        int l = i, r = m;
        while (l + 1 < r){
            int t = (l + r) / 2;
            if (check(i, t)){
                l = t;
            }
            else {
                r = t - 1;
            }
        }
        if (l != r && check(i, r)){
            l = r;
        }
        out++;
        i = l + 1;
    }
    cout<<out;
}