#include <iostream>
#include <map>
#include <set>

using namespace std;

#define ll long long

long long* input_numbers;
int length;
ll lower, upper;

map<ll, int>* cache;

int longest_subsequence(int start = 0, ll prev = -1) {
    // cout << "call " << start << " " << prev << "\n";
    // if (cache[start].find(prev) != cache[start].end()) {
    //     return cache[start][prev];
    // }

    if (start == length - 1) {
        return prev == -1 ? 1 : (lower <= input_numbers[start] + prev && input_numbers[start] + prev <= upper) ? 1 : 0;
    }

    int max_length = 0;

    set<ll> seen_numbers{};

    for (int i = start; i < length; i++) {
        if (seen_numbers.find(input_numbers[i]) != seen_numbers.end()) {
            // cout << "skip\n";
            continue;
        }

        if (prev != -1 && (input_numbers[i] + prev < lower || input_numbers[i] + prev > upper)) {
            seen_numbers.insert(input_numbers[i]);
            continue;
        }

        int new_length = longest_subsequence(i + 1, input_numbers[i]) + 1;

        if (new_length > max_length) {
            max_length = new_length;
        }

        seen_numbers.insert(input_numbers[i]);
    }

    // cache[start][prev] = max_length;

    return max_length;
}

int main() {
    cin >> length >> lower >> upper;

    input_numbers = new long long[length];
    cache = new map<ll, int>[length + 1];

    for (int i = 0; i < length; i++) {
        cin >> input_numbers[i];
        cache[i] = map<ll, int>{};
    }

    cout << longest_subsequence() << "\n";

    return 0;
}
