#include <iostream>
#include <map>

using namespace std;

#define ll long long

ll* input_numbers;
int length;
ll lower, upper;

map<int, int>* cache;

int longest_subsequence(int start = 0, ll prev = -1) {
    if (cache[start].find(prev) != cache[start].end()) {
        return cache[start][prev];
    }

    if (start == length - 1) {
        return prev == -1 ? 1 : (lower <= input_numbers[start] + prev && input_numbers[start] + prev <= upper) ? 1 : 0;
    }

    int max_length = 0;

    for (int i = start; i < length - max_length; i++) {
        if (prev != -1 && (input_numbers[i] + prev < lower || input_numbers[i] + prev > upper)) {
            continue;
        }

        int new_length = longest_subsequence(i + 1, input_numbers[i]) + 1;

        if (new_length > max_length) {
            max_length = new_length;
        }
    }

    cache[start][prev] = max_length;

    return max_length;
}

int main() {
    cin >> length >> lower >> upper;

    input_numbers = new long long[length];
    cache = new map<int, int>[length + 1];

    for (int i = 0; i < length; i++) {
        cin >> input_numbers[i];
        cache[i] = map<int, int>{};
    }

    cout << longest_subsequence() << "\n";

    return 0;
}
